//Effects

//I'm preloading the static images globally :o
var static_images = [];
for (var i = 1; i < 7; i++)
	static_images.push(LoadSurface("static"+i+".png"));

function StaticEffect(length) { //Length is in frames
	SetFrameRate(FPS);
	var staticsound = LoadSound("static.wav");
	staticsound.play(true);
	
	for (var i = 0; i < length; i++) {
		static_images[Math.floor(Math.random()*6)].blit(0, 0);
		FlipScreen();
	}
	
	staticsound.stop();
	SetFrameRate(0);
}



/** Handle map effects */
function Effect(_effect, length, params) {
	var effect = _effect;
	var time = 0;
	var maxtime = length ? length : 60;
	this.images = [];
	var value = 0; //A temp value the render method can use
	
	switch (effect) { //Init any necessart data.
		case "static":
		for (var i = 1; i < 7; i++) {
			this.images.push(LoadSurface("static"+i+".png"));
			this.images[i-1].setAlpha(Math.floor((params*255)/100));
			}
			break;
		
		case "fadetext": case "centertext":
			this.x = (SW-font.getStringWidth(params))/2;
			this.black = CreateColor(0,0,0);
			this.white = CreateColor(255,255,255);
			this.alpha = 0;
		
		case "speech":
			break;
		
		default:
			effect = ""; //In case it's a nonexistant effect, cancel it out
	}
	
	
	this.render = function() {
		if (effect == "") return;
		time++;
		
		switch (effect) {
			case "static":
				//Define what happens in a single frame of the static effect here
				//this.images[time%6].blit(0, 0);
				this.images[Math.floor(Math.random()*6)].blit(0, 0);
			break;
			
			case "fadetext": //More like tutorial text
				if (time/maxtime < 0.4)
					this.alpha = time/maxtime*255*2.5;
				else if (time/maxtime > 0.6)
					this.alpha = 510-time/maxtime*255*2;
				
				if (this.alpha < 0) this.alpha = 0;
				this.black.alpha = this.alpha;
				this.white.alpha = this.alpha;
				
				font.setColorMask(this.black);
				font.drawText(this.x-1, 139, params);
				font.drawText(this.x-1, 141, params);
				font.drawText(this.x+1, 139, params);
				font.drawText(this.x+1, 141, params);
				
				font.setColorMask(this.white);
				font.drawText(this.x, 140, params);
			break;
			
			case "centertext": //Like fadetext, without the fade
				font.setColorMask(Black);
				font.drawText(this.x-1, 139, params);
				font.drawText(this.x-1, 141, params);
				font.drawText(this.x+1, 139, params);
				font.drawText(this.x+1, 141, params);
				font.setColorMask(White);
				font.drawText(this.x, 140, params);
			break;
			
			case "speech": //Character speech
				font.setColorMask(White);
				var x = MapToScreenX(1,MOVEMENT.x-font.getStringWidth(params)/2);
				if (x < 0) x = 0; //Fix position
				else if (x+font.getStringWidth(params) > SW) x = SW-font.getStringWidth(params);
				var y = MapToScreenY(1,MOVEMENT.y-32);
				Rectangle(x-2, y-2, font.getStringWidth(params)+4, 12, Black);
				font.drawText(x, y, params);
			break;
		}
		
		if (maxtime == -1) return; //Never stop!
		if (time > maxtime) {
			time = 0;
			effect = "";
		}
	}
}



/** Convenience functions for quick FX */
function Speech(saywhat, time) {
	EFFECTS["speech"] = new Effect("speech", time, saywhat);
}

function FadeText(saywhat, time) {
	EFFECTS["fadetext"] = new Effect("fadetext", time, saywhat);
}


function CenterText(saywhat, time) {
	EFFECTS["centertext"] = new Effect("centertext", time, saywhat);
}