//Player & movement updating


/** Misnamed this right from the start. This is basically a Player class, not just its movement system. */
function PlayerMovement() {
	this.locked = false; //Unable to move; for cutscenes
	this.frozen = false; //Also freezes the "physics"
	this.mode = "oldman"; //Or "hacker"
	var moveanimationtime = 0;
	this.falltime = 0; //How long you've been in the air before landing.
	this.deathcount = 0;
	
	this.x = 0;  this.y = 0;
	var xv = 0; var yv = 0;
	var mxv = 7; var myv = 10; //Max velocity
	var grav = 0.2;
	var fric = 0.9;
	var dir = "east";
	
	var oldmanjumpstrength = 2.8; //Just about 1 block high :P
	var hackerjumpstrength = 8;
	
	var diesound = LoadSound("death.ogg");
	
	
	/** ================================= */
	/** Stuff that's updates in all cases */
	this.update = function() {
		this.x = GetPersonX("player");
		this.y = GetPersonY("player");
		
		if (AreZonesAt(this.x, this.y, GetPersonLayer("player"))) ExecuteZones(this.x, this.y, GetPersonLayer("player"));
		if (this.touched()) this.checkCollision();
		
		if (!this.locked) {
			if (this.mode == "oldman") this.updateOldMan();
			else this.updateHacker();
		}
		if (this.frozen) return;
		
		//x movement
		//Behold my horrible mess!
		if (xv < 0) dir = "west";
		else if (xv > 0) dir = "east";
		if (xv > mxv) xv = mxv;
		else if (xv < -mxv) xv = -mxv;
		if (xv < 0.2 && xv > -0.2) xv = 0;
		
		if (IsPersonObstructed("player",this.x+xv,this.y)) { //Push back if about to go through wall
			var moveback = 0;
			while (!IsPersonObstructed("player", this.x+moveback, this.y)) moveback+=xv;
			SetPersonX("player", GetPersonX("player")+moveback-xv);
			xv = 0;
		}
		else SetPersonX("player", GetPersonX("player")+xv);
		
		SetPersonDirection("player", dir+" "+this.mode);
		if (!IsPersonObstructed("player",this.x,this.y+1))
			SetPersonDirection("player",dir+" "+this.mode+" jump");
		else if (xv == 0)
			SetPersonFrame("player", 0);
		
		//Animation
		if (this.mode == "hacker") {
			if (xv != 0 && yv == 0) //Moving and not in the air
				moveanimationtime++;
			else moveanimationtime = 0;
			if (moveanimationtime < 8)
				QueuePersonCommand("player",COMMAND_ANIMATE,true);
		}
		else if (xv == 0 || IsPersonObstructed("player",this.x,this.y+1))
			QueuePersonCommand("player",COMMAND_ANIMATE,true);
		
		//y
		if (yv < myv) yv += grav; //Always be pulled downwards
		if (yv > 0 && IsPersonObstructed("player",this.x,this.y+yv+1)) { //About to touch floor?
			var movedown = 0;
			while (!IsPersonObstructed("player", this.x, this.y+movedown)) movedown++;
			if (this.mode == "oldman" && this.falltime >= 35) this.die();
			SetPersonY("player", GetPersonY("player")+movedown-1);
			this.falltime = 0;
			yv = 0;
		}
		else { //Still falling?
			if (yv < 0 && IsPersonObstructed("player",this.x,this.y+yv)) yv = 1; //Ceiling check
			else if (yv > 0) this.falltime++;
			if (this.mode == "oldman" && this.falltime >= 35) Speech("AAAAAAAHHHH!!!", 20);
			SetPersonY("player", GetPersonY("player")+yv);
		}
	}
	
	
	/** ===================== */
	/** Old man controls **/
	this.updateOldMan = function()
	{
		//x
		if (ButtonPressed("left") && xv > -1)
			xv = -1;
		else if (ButtonPressed("right") && xv < 1)
			xv = 1;
		else xv *= fric;
		
		//y
		if (ButtonPressed("a") && IsPersonObstructed("player",this.x,this.y+1)) yv = -oldmanjumpstrength;
	}
	
	
	
	/** ===================== */
	/** Hacker controls **/
	this.updateHacker = function()
	{
		if (ButtonPressed("left")) xv-=0.5;
		else if (ButtonPressed("right")) xv+=0.5;
		else xv *= fric;
		
		if (ButtonPressed("a") && IsPersonObstructed("player",this.x,this.y+1)) yv = -hackerjumpstrength;
	}
	
	
	/** Convenience function for checking if you're overlapping stuff */
	this.touched = function() {
		return GetObstructingPerson("player", GetPersonX("player")+xv, GetPersonY("player")+yv);
	}
	
	
	/** Check what the character is colliding with and act accordingly */
	this.checkCollision = function() {
		if (this.touched().substr(0, 4) == "item" && this.mode == "oldman")
			INVENTORY.get(this.touched().substr(5));
		else if (this.touched().substr(0, 45) == "death")
			this.die();
		else if (this.touched().substr(0,4) == "lift")
			EndGame(); //Aww...
		
		//Other stuff: enemies? Warp portals (hacker only)? Terminals (for the hacker to open doors)? Flight powerup?
	}
	
	
	/** Move to a different spot on the map, or even a different map */
	this.warp = function(map, x, y) {
		if (this.mode == "hacker") StaticEffect(10);
		if (map) WORLD.switchMap(map);
		if (x) SetPersonX("player", x*GetTileWidth());
		if (y) SetPersonY("player", y*GetTileHeight());
	}
	
	
	/** Player dies :( */
	this.die = function() {
		this.deathcount++;
		diesound.play(false);
		SetFrameRate(FPS);
		var c = CreateColor(255,0,0);
		while (!ButtonPressed("a")) {
			if (c.red > 10) c.red-=10; else c.red = 0;
			Rectangle(0, 0, SW, SH, c);
			font.drawText(135, 100, "Oh dear. You died.");
			font.drawText(85, 240, "Press Z or button 1 to continue");
			FlipScreen();
		}
		SetFrameRate(0); //Fix stupid Sphere bug
		diesound.stop();
		WORLD.reset();
	}
	
	
	this.debug = function() {
		var n = -10;
		font.drawText(100, n+=10, "Pos:"+this.x+","+this.y);
		font.drawText(100, n+=10, "Mode:"+this.mode);
		font.drawText(100, n+=10, "Locked:"+this.locked);
		font.drawText(100, n+=10, "In air:"+this.falltime);
	}
}