//Remember the world
//Also takes care of the timer

function World() {
	this.map = ""; //Current map name
	this.state = "light";
	this.maxtime = 10*FPS; //10 seconds
	this.timer = this.maxtime;
	
	this.music = [];
	this.music["light"] = LoadSound("light.ogg", true);
	this.music["dark"] = LoadSound("dark.ogg", true);
	
	
	/** Init world **/
	this.init = function() {
		this.music["light"].play(true);
		SetRenderScript("RenderScript()");
		SetUpdateScript("UpdateScript()");
		WORLD.switchMap("01"); //Let'sa go!
	}
	
	
	/** Reset map and world and movement */
	this.reset = function() {
		MOVEMENT = new PlayerMovement();
		for (var i in EVENTS.eventlist) {
			EVENTS.eventlist[i].reset();
		}
		
		this.state = "dark";
		MOVEMENT.mode = "hacker";
		this.flip();
		this.switchMap(this.map);
	}
	
	
	this.update = function() {
		this.timer--;
		if (this.timer <= 0) {
			this.flip();
		}
	}
	
	
	this.render = function() {
		font.setColorMask(Red);
		font.drawText(360, 10, parseFloat(this.timer/60).toFixed(2));
		font.setColorMask(White);
	}
	
	
	/* Flip into the other world! */
	this.flip = function() {
		this.timer = this.maxtime;
		SetDefaultMapScript(SCRIPT_ON_ENTER_MAP, "");
		StaticEffect(20);
		this.music[this.state].pause();
		this.state = (this.state == "light") ? "dark" : "light"; //Flip between world states
		this.music[this.state].play(true);
		
		this.switchMap(this.map);
		SetPersonX("player", MOVEMENT.x);
		SetPersonY("player", MOVEMENT.y);
		UpdateCamera();
		MOVEMENT.falltime = 0; //Give the old man a chance
		
		MOVEMENT.mode = (MOVEMENT.mode == "oldman") ? "hacker" : "oldman";
		
		if (EFFECTS["speech"]) delete EFFECTS["speech"]; //Stop talking
		
		if (this.state == "dark")
			EFFECTS["static"] = new Effect("static", -1, 25); //test
		else delete EFFECTS["static"];
	}
	
	
	this.switchMap = function(whichmap) {
		this.map = whichmap;
		var mapname = this.state + "/" + whichmap + ".rmp";  //Ex. light/mymap.rmp
		if (!IsMapEngineRunning()) MapEngine(mapname, FPS);
		else ChangeMap(mapname);
		INVENTORY.check();
		EVENTS.persist(); //Invoke the persistent elements that some events may have
	}
	
	
	/** Run this when map zones are triggered. */
	this.triggerZone = function(zone) {
		switch (this.map) {
			case "01":
				if (zone == "door" && INVENTORY.has("key 01"))
					EVENTS.trigger("door 01 opened");
				else if (zone == "door")
					Speech("Where did I leave my keys...?", 120);
			break;
		}
	}
	
	
	this.debug = function() {
		if (ButtonPressed("x")) { //Note: "x" as in gamepad "x". Mapped to S on keyboard.
			this.flip();
		}
	}
}




function DoesPersonExist(who) {
	var people = GetPersonList();
	for (var i in people)
		if (people[i] == who) return true;
	return false;
}